﻿using System;
using System.Collections.Generic;
using System.Diagnostics;
using System.Linq;
using System.Text;
using System.Threading.Tasks;

namespace TPLSamples.Models
{
    public class MatricesMultiplicationParallelSample : MatricesMultiplicationSample
    {
        public override string SampleName
        {
            get { return "Matrices Multiplication Parallel"; }
        }

        public override void Run(System.Drawing.Bitmap bmp = null, Action<string> updateLog = null)
        {
            double[,] matA = Matrix1;
            double[,] matB = Matrix2;
            double[,] result = new double[rowCount, colCount2];

            Stopwatch s = new Stopwatch();
            s.Start();

            int matACols = matA.GetLength(1);
            int matBCols = matB.GetLength(1);
            int matARows = matA.GetLength(0);

            // A basic matrix multiplication.
            // Parallelize the outer loop to partition the source array by rows.
            Parallel.For(0, matARows, i =>
            {
                for (int j = 0; j < matBCols; j++)
                {
                    double temp = 0;
                    for (int k = 0; k < matACols; k++)
                    {
                        temp += matA[i, k] * matB[k, j];
                    }
                    result[i, j] = temp;
                }
            });

            s.Stop();
            RunTime = s.Elapsed;
        }
    }
}
